class Customer < ActiveRecord::Base
  has_many :coitems
  has_many :bitems
  has_many :merchandise_purchases
  has_many :rentable_purchases

  validates_presence_of :name, :email, :phone, :address
  validates_numericality_of :debt

  protected

  def validate
    errors.add(:debt, "should be non-negative") if debt.nil? || debt < 0.00
  end

end
