class Merchandise < ActiveRecord::Base
  has_many :merchandise_purchases

  validates_presence_of :name
  validates_numericality_of :quantity
  validates_numericality_of :price

  protected
  def validate
    errors.add(:quantity, "cannot be negative") if quantity < 0
    errors.add(:price, "cannot be negative") if price < 0
    errors.add(:price, "cannot be less than $0.01") if price < 0.01
  end
end
