require File.dirname(__FILE__) + '/../test_helper'
require 'merchandise_controller'

# Re-raise errors caught by the controller.
class MerchandiseController; def rescue_action(e) raise e end; end

class MerchandiseControllerTest < Test::Unit::TestCase
  fixtures :merchandises

  def setup
    @controller = MerchandiseController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = merchandises(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:merchandises)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:merchandise)
    assert assigns(:merchandise).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:merchandise)
  end

  def test_create
    num_merchandises = Merchandise.count

    post :create, :merchandise => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_merchandises + 1, Merchandise.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:merchandise)
    assert assigns(:merchandise).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Merchandise.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Merchandise.find(@first_id)
    }
  end
end
